package com.link.core.basic.lock;

import com.link.core.cache.MethodAnnotationPointcutAdvisor;
import javax.annotation.Resource;
import org.springframework.aop.support.AbstractPointcutAdvisor;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class LinkLockConfig {
   @Resource
   private LockConfigure lockConfigure;

   @Bean
   @ConditionalOnMissingBean({LockHandler.class})
   public LockHandler linkLockHandler() {
      LockHandler lockHandler = new LockHandler(this.lockConfigure);
      return lockHandler;
   }

   @Bean
   @ConditionalOnBean({LockHandler.class})
   public LockInterceptor linkLockInterceptor(LockHandler lockHandler) {
      return new LockInterceptor(lockHandler);
   }

   @Bean({"lockAdvisor"})
   @ConditionalOnBean({LockInterceptor.class})
   public AbstractPointcutAdvisor linkLockAdvisor(LockInterceptor lockInterceptor) {
      AbstractPointcutAdvisor lockAdvisor = new MethodAnnotationPointcutAdvisor(LinkLock.class, lockInterceptor);
      lockAdvisor.setOrder(this.lockConfigure.getLockOrder());
      return lockAdvisor;
   }
}
